######################################################
#   Simple Trigger Mod by h!gh voltage (stonedegg)   #
#                                                    #
#            This addon lets you create              #
#       your own triggers with destinations.         #
######################################################


""" Edit Admins in the following list """
admins = ['STEAM_ID','STEAM_ID', 'STEAM_ID']



import es
import os
import playerlib
import popuplib
import cmdlib
import vecmath
import gamethread
import effectlib
import cPickle
import psyco
psyco.full()

info = es.AddonInfo()
info.author      = "h!gh voltage"
info.name        = "Trigger Mod"
info.basename    = "trigger"
info.version     = "1.0.2"
info.description = "Lets you create your own triggers!"
es.ServerVar('trigger_mod', info.version).makepublic()

zones = {}
count = {}
effects = []
current_zone = {}

currentMap = es.ServerVar('eventscripts_currentmap')

database1 = os.path.join(es.getAddonPath(info.basename), "data.db" )
if os.path.isfile(database1):
    file = open(database1, 'r')
    zones = cPickle.load(file)
    file.close()

database2 = os.path.join(es.getAddonPath(info.basename), "count.db" )
if os.path.isfile(database2):
    file = open(database2, 'r')
    count = cPickle.load(file)
    file.close()

def load():
    cmdlib.registerSayCommand('!trigger', menu, 'Trigger Admin Menu')
    gamethread.delayedname(1, 'check_loop', checkloop)

def unload():
    savedatabase()
    cmdlib.unregisterSayCommand('!trigger')
    gamethread.cancelDelayed('check_loop')
    gamethread.cancelDelayed('effect_loop')
    gamethread.cancelDelayed('view_loop')

def es_map_start(ev):
    savedatabase()

def savedatabase():
    file = open(database1, 'w')
    cPickle.dump(zones, file)
    file.close()
    file = open(database2, 'w')
    cPickle.dump(count, file)
    file.close()

def menu(userid, args):
    steamid = es.getplayersteamid(userid)
    if steamid in admins:
        menu = popuplib.create('trigger_menu')
        menu.addline('Trigger Menu')
        menu.addline(' ')
        menu.addline('- Trigger')
        menu.addline('->1. Add')
        menu.addline('->2. Change')
        menu.addline('->3. Delete')
        menu.addline('->4. View')
        menu.addline(' ')
        menu.addline('->5. Save')
        menu.addline(' ')
        menu.addline('0. Close')
        menu.unsend(userid)
        menu.send(userid)
        menu.delete()
        menu.menuselect = menuSelect
    else: es.tell(userid, 'You are not authorized to run this command!')

def menuSelect(userid, choice, popupid):
    map = str(currentMap)
    player = playerlib.getPlayer(userid)
    if choice == 1:
        if player.isdead == 0:
            if map not in count:
                count[map] = 1
            else:
                count[map] += 1
            addzone(userid)
        else:
            es.tell(userid, 'You must be alive to add a zone!')
            menu(userid, None)

    elif choice == 2:
        if player.isdead == 0:
            if map in zones:
                changezonelist(userid)
            else: 
                es.tell(userid, 'There are no zones.')
                menu(userid, None)
        else:
            es.tell(userid, 'You must be alive to add a zone!')
            menu(userid, None)

    elif choice == 3:
        if map in zones:
            delzonelist(userid)
        else: 
            es.tell(userid, 'There are no zones.')
            menu(userid, None)

    elif choice == 4:
        if map in zones:
            viewzonelist(userid)
        else:
            es.tell(userid, 'There are no zones.')
            menu(userid, None)

    elif choice == 5:
        savedatabase()
        es.tell(userid, 'You saved the database.')

def addzone(userid):
    map = str(currentMap)
    addz = popuplib.create('add_zone')
    addz.addline('Add Trigger #%s'%count[map])
    addz.addline(' ')
    addz.addline('- Add')
    addz.addline('->1. Trigger Positions')
    addz.addline('->2. Teleport Destination')
    addz.addline('->3. Use spawnloc as Destination')
    team = "All"
    zname = 'trigger_%s'%count[map]
    if map in zones and zname in zones[map]:
        if 'team' in zones[map][zname]:
            if zones[map][zname]['team'] == 'all':
                team = "All"
            elif zones[map][zname]['team'] == 'ct':
                team = "CT-Only"
            elif zones[map][zname]['team'] == 't':
                team = "T-Only"
    addz.addline('->4. Team: %s'%team)
    addz.addline(' ')
    addz.addline('->9. Done')
    addz.unsend(userid)
    addz.send(userid)
    addz.delete()
    addz.menuselect = addmenuSelect

def addmenuSelect(userid, choice, popupid):
    map = str(currentMap)
    if choice == 1:
        if map not in zones: zones[map] = {}
        zname = 'trigger_%s'%count[map]
        if userid not in effects:
            effects.append(userid)
            zones[map][zname] = {}
            if 'pos' not in zones[map][zname]:
                zones[map][zname]['pos'] = [(0,0,0),(0,0,0)]
            pos = list(es.getplayerlocation(userid))
            zones[map][zname]['pos'][0] = pos
            effectLoop(userid, pos, 0, 0, 255)
            es.tell(userid, 'You have chosen the first point of the trigger.')
            zones[map][zname]['team'] = 'all'
            addzone(userid)
        else:
            effects.remove(userid)
            zones[map][zname]['pos'][1] = list(es.getplayerlocation(userid))
            zones[map][zname]['pos'][1][2] -= 5
            es.tell(userid, 'You have chosen the second point of the trigger.')
            gamethread.cancelDelayed('effect_loop')
            addzone(userid)
    elif choice == 2:
        zname = 'trigger_%s'%count[map]
        if map not in zones or zname not in zones[map]:
            es.tell(userid, 'Please add the trigger positions before.')
            addzone(userid)
        else:
            zones[map][zname]['dest'] = es.getplayerlocation(userid)
            es.tell(userid, 'Successfully added the trigger destination.')
            addzone(userid)
    elif choice == 3:
        zname = 'trigger_%s'%count[map]
        if map not in zones or zname not in zones[map]:
            es.tell(userid, 'Please add the trigger positions before.')
            addzone(userid)
        else:
            zones[map][zname]['dest'] = 'player_spawn'
            es.tell(userid, 'Successfully added the trigger destination.')
            addzone(userid)
    elif choice == 4:
        zname = 'trigger_%s'%count[map]
        if map not in zones or zname not in zones[map]:
            es.tell(userid, 'Please add the trigger positions before.')
            addzone(userid)
        else:
            if zones[map][zname]['team'] == 'all':
                zones[map][zname]['team'] = 'ct'
                addzone(userid)
            elif zones[map][zname]['team'] == 'ct':
                zones[map][zname]['team'] = 't'
                addzone(userid)
            elif zones[map][zname]['team'] == 't':
                zones[map][zname]['team'] = 'all'
                addzone(userid)
    elif choice == 9:
        zname = 'trigger_%s'%count[map]
        if map not in zones or zname not in zones[map] or 'dest' not in zones[map][zname]:
            es.tell(userid, 'You did not set the positions.')
            addzone(userid)
        else:
            menu(userid, None)
    elif choice in (5,6,7,8): addzone(userid)

def changezonelist(userid):
    map = str(currentMap)
    czl = popuplib.easymenu('change_zone_list', None, czlhandler)
    czl.settitle('Choose a trigger to change:')
    for zname in sorted(zones[map]):
        czl.addoption(zname, zname)
    czl.unsend(userid)
    czl.send(userid)

def czlhandler(userid, choice, popupid):
    changezone(userid, choice)

def changezone(userid, zone):
    map = str(currentMap)
    current_zone[userid] = zone
    cz = popuplib.create('change_zone')
    cz.addline('Change %s:'%zone)
    cz.addline(' ')
    cz.addline('- Change')
    cz.addline('->1. Trigger Positions')
    cz.addline('->2. Trigger Destination')
    cz.addline('->3. Use spawnloc as Destination')
    team = "All"
    if 'team' in zones[map][zone]:
        if zones[map][zone]['team'] == 'all':
            team = "All"
        elif zones[map][zone]['team'] == 'ct':
            team = "CT-Only"
        elif zones[map][zone]['team'] == 't':
            team = "T-Only"
    cz.addline('->4. Team: %s'%team)
    cz.addline(' ')
    cz.addline('->9. Back')
    cz.addline('0. Close')
    cz.unsend(userid)
    cz.send(userid)
    cz.delete()
    cz.menuselect = czSelect

def czSelect(userid, choice, popupid):
    map = str(currentMap)
    if choice == 1:
        if userid not in effects:
            effects.append(userid)
            pos = list(es.getplayerlocation(userid))
            zones[map][current_zone[userid]]['pos'][0] = pos
            effectLoop(userid, pos, 0, 0, 255)
            es.tell(userid, 'You have changed the first point of the trigger.')
            changezone(userid, current_zone[userid])
        else:
            effects.remove(userid)
            gamethread.cancelDelayed('effect_loop')
            zones[map][current_zone[userid]]['pos'][1] = list(es.getplayerlocation(userid))
            es.tell(userid, 'You have changed the second point of the trigger.')
            changezone(userid, current_zone[userid])
    elif choice == 2:
        zones[map][current_zone[userid]]['dest'] = es.getplayerlocation(userid)
        es.tell(userid, 'Successfully changed the trigger destination.')
        changezone(userid, current_zone[userid])
    elif choice == 3:
        zones[map][current_zone[userid]]['dest'] = 'player_spawn'
        es.tell(userid, 'Successfully changed the trigger destination.')
        changezone(userid, current_zone[userid])
    elif choice == 4:
        if zones[map][current_zone[userid]]['team'] == 'all':
            zones[map][current_zone[userid]]['team'] = 'ct'
            changezone(userid, current_zone[userid])
        elif zones[map][current_zone[userid]]['team'] == 'ct':
            zones[map][current_zone[userid]]['team'] = 't'
            changezone(userid, current_zone[userid])
        elif zones[map][current_zone[userid]]['team'] == 't':
            zones[map][current_zone[userid]]['team'] = 'all'
            changezone(userid, current_zone[userid])
    elif choice == 9:
        menu(userid, None)
    elif choice in (5,6,7,8): changezone(userid, current_zone[userid])

def delzonelist(userid):
    map = str(currentMap)
    dzl = popuplib.easymenu('del_zone_list', None, dzlhandler)
    dzl.settitle('Choose a trigger to delete:')
    for zname in sorted(zones[map]):
        dzl.addoption(zname, zname)
    dzl.unsend(userid)
    dzl.send(userid)

def dzlhandler(userid, choice, popupid):
    delzone(userid, choice)

def delzone(userid, zone):
    map = str(currentMap)
    current_zone[userid] = zone
    dz = popuplib.create('delete_zone')
    dz.addline('Delete %s'%zone)
    dz.addline(' ')
    dz.addline('->1. Confirm')
    dz.addline(' ')
    dz.addline('->9. Back')
    dz.addline('0. Close')
    dz.unsend(userid)
    dz.send(userid)
    dz.delete()
    dz.menuselect = dzSelect

def dzSelect(userid, choice, popupid):
    map = str(currentMap)
    if choice == 1:
        del zones[map][current_zone[userid]]
        es.tell(userid, 'You successfully deleted %s.'%current_zone[userid])
        menu(userid, None)
    elif choice == 9:
        delzonelist(userid)
    elif choice in (2,3,4,5,6,7,8): delzone(userid, current_zone[userid])

def viewzonelist(userid):
    map = str(currentMap)
    vzl = popuplib.easymenu('view_zone_list', None, vzlhandler)
    vzl.settitle('Choose a trigger to view:')
    for zname in sorted(zones[map]):
        vzl.addoption(zname, zname)
    vzl.unsend(userid)
    vzl.send(userid)

def vzlhandler(userid, choice, popupid):
    viewzone(userid, choice)

def viewzone(userid, zone):
    map = str(currentMap)
    current_zone[userid] = zone
    vz = popuplib.create('view_zone')
    vz.addline('View %s'%zone)
    vz.addline(' ')
    vz.addline('->1. Toggle highlight trigger')
    vz.addline('->2. Teleport to trigger destination')
    vz.addline(' ')
    vz.addline('->9. Back')
    vz.addline('0. Close')
    vz.unsend(userid)
    vz.send(userid)
    vz.delete()
    vz.menuselect = vzSelect

def vzSelect(userid, choice, popupid):
    map = str(currentMap)
    zname = current_zone[userid]
    if choice == 1:
        if userid not in effects:
            effects.append(userid)
            viewLoop(userid, zones[map][zname]['pos'][0], zones[map][zname]['pos'][1], 0, 0, 255)
            es.tell(userid, 'Highlighting trigger...')
        else:
            effects.remove(userid)
            gamethread.cancelDelayed('view_loop')
            es.tell(userid, 'Stopped highlighting trigger.')
        viewzone(userid, zname)
    elif choice == 2:
        dest = zones[map][zname]['dest']
        if dest == 'player_spawn':
            es.server.insertcmd('es_xspawnplayer %s' %userid)
        else:
            es.server.queuecmd('es_setpos %s %s %s %s' %(userid, dest[0], dest[1], dest[2]))
        es.tell(userid, 'You teleported yourself to the trigger destination.')
        viewzone(userid, zname)
    elif choice == 9:
        menu(userid, None)

def viewLoop(userid, pos1, pos2, red, green, blue):
    effectlib.drawBox(pos1, pos2, red=red, green=green, blue=blue, seconds=0.1)
    gamethread.delayedname(0.1, 'view_loop', viewLoop, (userid, pos1, pos2, red, green, blue))

def effectLoop(userid, pos, red, green, blue):
    effectlib.drawBox(pos, es.getplayerlocation(userid), red=red, green=green, blue=blue, seconds=0.1)
    gamethread.delayedname(0.1, 'effect_loop', effectLoop, (userid, pos, red, green, blue))

def checkloop():
    map = str(currentMap)
    if map in zones:
        for userid in es.getUseridList():
            player = playerlib.getPlayer(userid)
            if player.isdead == 0:
                for zname in zones[map]:
                    if 'pos' in zones[map][zname] and 'dest' in zones[map][zname]:
                        loc1, loc2 = zones[map][zname]['pos']
                        dest = zones[map][zname]['dest']
                        if 'team' not in zones[map][zname]:
                            zones[map][zname]['team'] = 'all'
                        if vecmath.isbetweenRect(es.getplayerlocation(userid), loc1, loc2):
                            if zones[map][zname]['team'] == 'all':
                                if zones[map][zname]['dest'] == 'player_spawn':
                                    es.server.insertcmd('es_xspawnplayer %s' %userid)
                                else:
                                    es.server.queuecmd('es_setpos %s %s %s %s' %(userid, dest[0], dest[1], dest[2]))
                            elif zones[map][zname]['team'] == 'ct':
                                if es.getplayerteam(userid) == 3:
                                    if zones[map][zname]['dest'] == 'player_spawn':
                                        es.server.insertcmd('es_xspawnplayer %s' %userid)
                                    else:
                                        es.server.queuecmd('es_setpos %s %s %s %s' %(userid, dest[0], dest[1], dest[2]))
                            elif zones[map][zname]['team'] == 't':
                                if es.getplayerteam(userid) == 2:
                                    if zones[map][zname]['dest'] == 'player_spawn':
                                        es.server.insertcmd('es_xspawnplayer %s' %userid)
                                    else:
                                        es.server.queuecmd('es_setpos %s %s %s %s' %(userid, dest[0], dest[1], dest[2]))

    gamethread.delayedname(0.1, 'check_loop', checkloop)



